﻿using System;
using System.IO;

namespace LogService.Impl
{
    public class TxtLogService : ILogService
    {
        private static readonly string logDir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "log");

        private static readonly object objSync = new object();

        public void AppendLog(params string[] messages)
        {
            Console.WriteLine("Append log to .txt file.");
            var logFilePath = Path.Combine(logDir, DateTime.Now.ToString("yyyy-MM-dd") + ".txt");
            lock (objSync)
            {
                if (Directory.Exists(logDir) == false)
                {
                    Directory.CreateDirectory(logDir);
                }
                //if (File.Exists(logFilePath) == false)
                //{
                //    File.Create(logFilePath);
                //}
                if (messages == null || messages.Length == 0)
                {
                    return;
                }
                File.AppendAllText(logFilePath, string.Join("\r\n", messages));
                File.AppendAllText(logFilePath, "\r\n");
            }
        }
    }
}
