﻿using System;
using System.Threading.Tasks;
using System.Web.Mvc;
using System.Web.Security;
using MVCApp.Helper;
using UserService;

namespace MVCApp.Controllers
{
    public class AccountController : BaseController
    {
        private readonly IUserService userService = null;

        public AccountController(IUserService userService)
        {
            this.userService = userService;
            //var userInfo = userService.GetCurrentUser();//do sth
        }

        public ActionResult Index()
        {
            //var userInfo = userService.GetCurrentUser();
            var user = CurrentUser;
            if (user != null)
            {
                return RedirectToAction("Index", "Home");
            }
            return View();
        }

        public ActionResult Login()
        {
            //for (int i = 10000; i < 15000; i++)
            //{
            //    var num = i;
            //    Task.Factory.StartNew(() =>
            //    {
            //        CurrentLogService.AppendLog(num.ToString());
            //    });
            //}

            CurrentUserService.Login("jeffwong", Guid.NewGuid().ToString());
            return RedirectToAction("Index", "Home");
        }

        [UserAuth]
        public ActionResult Logout()
        {
            CurrentUserService.Logout();
            FormsAuthentication.RedirectToLoginPage();
            return new EmptyResult();
        }
    }
}
