﻿using System.Web.Mvc;
using LogService;
using Ninject;
using UserService;
using UserService.Model;

namespace MVCApp.Helper
{
    [ExceptionHandle]
    public class BaseController : Controller
    {
        /// <summary>
        /// 构造函数
        /// </summary>
        public BaseController()
        {
            if (CurrentLogService==null)
            {
                using (var kernel = new StandardKernel(new ServiceModule()))
                {
                    var logger = kernel.Get<ILogService>();
                    logger.AppendLog("As you see,in constructor log service is not initilized by inject attribute.");
                }
            }
        }

        protected UserInfo CurrentUser
        {
            get { return CurrentUserService.CurrentUser; }
        }

        #region 服务

        [Inject]
        public IUserService CurrentUserService { get; set; }

        [Inject]
        public ILogService CurrentLogService { get; set; }

        #endregion
    }
}
