﻿using LogService;
using LogService.Impl;
using Ninject.Modules;
using NinjectApp.Warrior;
using NinjectApp.Weapon;

namespace NinjectApp
{
    internal class ServiceModule : NinjectModule
    {
        public override void Load()
        {
            Bind<ILogService>().To<DbLogService>();

            Bind<IWeapon>().To<Sword>().InSingletonScope();
            //Bind<IWeapon>().To<Shuriken>();

            Bind<Shuriken>().ToSelf().WhenInjectedInto<IWeapon>();

            Bind<IWarrior>().To<FootSoldier>();
            //Bind<IWarrior>().To<Samurai>();

        }
    }
}
