﻿//using System;
//using Ninject;
//using Ninject.Activation;
//using Ninject.Infrastructure.Disposal;
//using NinjectApp.Weapon;
//using NUnit.Framework;

//namespace NinjectApp.Test
//{
//    [TestFixture]
//    public class SingletonScopeContext
//    {
//        protected StandardKernel kernel;

//        public SingletonScopeContext()
//        {
//            this.SetUp();
//        }

//        public void SetUp()
//        {
//            this.kernel = new StandardKernel();
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToInterfaceInSingletonScope : SingletonScopeContext
//    {
//        [Test]
//        public void FirstActivatedInstanceIsReused()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InSingletonScope();

//            var instance1 = kernel.Get<IWeapon>();
//            var instance2 = kernel.Get<IWeapon>();

//            Assert.AreEqual(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreNotGarbageCollectedAsLongAsKernelRemainsAlive()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InSingletonScope();

//            var instance = kernel.Get<IWeapon>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }

//        [Test]
//        public void InstancesAreDeactivatedWhenKernelIsDisposed()
//        {
//            kernel.Bind<INotifyWhenDisposed>().To<NotifiesWhenDisposed>().InSingletonScope();

//            var instance = kernel.Get<INotifyWhenDisposed>();
//            kernel.Dispose();

//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToSelfInSingletonScope : SingletonScopeContext
//    {
//        [Test]
//        public void FirstActivatedInstanceIsReused()
//        {
//            kernel.Bind<Sword>().ToSelf().InSingletonScope();

//            var sword1 = kernel.Get<Sword>();
//            var sword2 = kernel.Get<Sword>();

//            Assert.AreSame(sword1, sword2);
//        }

//        [Test]
//        public void InstancesAreNotGarbageCollectedAsLongAsKernelRemainsAlive()
//        {
//            kernel.Bind<NotifiesWhenDisposed>().ToSelf().InSingletonScope();

//            var instance = kernel.Get<NotifiesWhenDisposed>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }

//        [Test]
//        public void InstancesAreDeactivatedWhenKernelIsDisposed()
//        {
//            kernel.Bind<NotifiesWhenDisposed>().ToSelf().InSingletonScope();

//            var instance = kernel.Get<NotifiesWhenDisposed>();
//            kernel.Dispose();

//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToProviderInSingletonScope : SingletonScopeContext
//    {
//        [Test]
//        public void FirstActivatedInstanceIsReused()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToProvider<NotifiesWhenDisposedProvider>().InSingletonScope();

//            var instance1 = kernel.Get<INotifyWhenDisposed>();
//            var instance2 = kernel.Get<INotifyWhenDisposed>();

//            Assert.AreSame(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreNotGarbageCollectedAsLongAsKernelRemainsAlive()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToProvider<NotifiesWhenDisposedProvider>().InSingletonScope();

//            var instance = kernel.Get<INotifyWhenDisposed>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }

//        [Test]
//        public void InstancesAreDeactivatedWhenKernelIsDisposed()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToProvider<NotifiesWhenDisposedProvider>().InSingletonScope();

//            var instance = kernel.Get<INotifyWhenDisposed>();
//            kernel.Dispose();

//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToMethodInSingletonScope : SingletonScopeContext
//    {
//        [Test]
//        public void FirstActivatedInstanceIsReused()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToMethod(x => new NotifiesWhenDisposed()).InSingletonScope();

//            var instance1 = kernel.Get<INotifyWhenDisposed>();
//            var instance2 = kernel.Get<INotifyWhenDisposed>();

//            Assert.AreSame(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreNotGarbageCollectedAsLongAsKernelRemainsAlive()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToMethod(x => new NotifiesWhenDisposed()).InSingletonScope();

//            var instance = kernel.Get<INotifyWhenDisposed>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }

//        [Test]
//        public void InstancesAreDeactivatedWhenKernelIsDisposed()
//        {
//            kernel.Bind<INotifyWhenDisposed>().ToMethod(x => new NotifiesWhenDisposed()).InSingletonScope();

//            var instance = kernel.Get<INotifyWhenDisposed>();
//            kernel.Dispose();

//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }

//    public class NotifiesWhenDisposedProvider : Provider<NotifiesWhenDisposed>
//    {
//        protected override NotifiesWhenDisposed CreateInstance(IContext context)
//        {
//            return new NotifiesWhenDisposed();
//        }
//    }
//}
